#include <stdio.h>
#include <stdlib.h>
/*
#include <stdarg.h>
*/
#include "wv_matalloc.h"

#define loc4(i,j,k,l) (i*q*p*n + j*q*p + k*q + l)
#define loc2(i,j) (i*nc + j)
#define L 24
#define M 100
#define N 133

void fourdimtest(int ****a,int m, int n, int p, int q)
{
   int *x;
   int i,j,k,l;
   int counter,fault;
   x=***a;

   for (i=0; i<m; i++)
      for (j=0; j<n; j++)
	 for (k=0; k<p; k++)
	    for (l=0; l<q; l++)
	       a[i][j][k][l]=1000*i+100*j+10*k+l;

   counter = fault = 0;
   for (i=0; i<m; i++)
      for (j=0; j<n; j++)
	 for (k=0; k<p; k++)
	    for (l=0; l<q; l++)
	    { counter++;
	       if (x[loc4(i,j,k,l)] != a[i][j][k][l])
	       {
		  printf("ijkl: %d %d %d %d %d %d\n",i,j,k,l,
			x[loc4(i,j,k,l)],a[i][j][k][l]);
		  fault++;
	       }
	    }
   printf("checked %d arrayelements, %d errors\n",counter,fault);
}
void onedimtest(double *b, unsigned int nb)
{
   unsigned int i;
   int counter, fault;
   for (i=0; i<nb; i++)
      b[i]=i;

   counter=fault=0;

   for (i=0; i<nb; i++)
   {
      counter++;
      if (b[i] != i)
      {
	 printf("i: %d %f\n",i,b[i]);
	 fault++;
      } 
   }

   printf("checked %d arrayelements, %d errors\n",counter,fault);
}
void twodimtest(double **c, int mc, int nc)
{
   double *y;
   int i,j,counter,fault;
   y=*c;
   for (i=0; i<mc; i++)
      for (j=0; j<nc; j++)
	 c[i][j]=1000*i+j;

   counter = fault = 0;
   for (i=0; i<mc; i++)
      for (j=0; j<nc; j++)
      { counter++;
	 if (y[loc2(i,j)] != c[i][j])
	 {
	    printf("ij: %d %d %f %f\n",i,j,
		  y[loc2(i,j)],c[i][j]);
	    fault++;
	 }
      }
   printf("checked %d arrayelements, %d errors\n",counter,fault);
}
void threedimtest(double ***dd, int l, int m, int n, double d[l][m][n])
{
   int i,j,k,counter,fault;
   for (i=0; i<l; i++)
      for (j=0; j<m; j++)
	 for (k=0; k<n; k++)
	    dd[i][j][k]=10000*i+100*j+k;

   counter = fault = 0;
   for (i=0; i<l; i++)
      for (j=0; j<m; j++)
	 for (k=0; k<n; k++)
	 { counter++;
	    if (d[i][j][k] != dd[i][j][k])
	    {
	       printf("ijk: %d %d %d %f %f\n",i,j,k,
		     d[i][j][k],dd[i][j][k]);
	       fault++;
	    }
	 }
   printf("checked %d arrayelements, %d errors\n",counter,fault);
}
int main(void)
{
   int ****a;
   int m,n,p,q;
   unsigned int *dims;

   double *b;
   unsigned int nb;

   double **c;
   int mc,nc;

   double d[L][M][N];
   double ***dd;

   m=60; n=11; p=37; q=21;
   printf("4-dim test wv_matalloc: %d %d %d %d\n",m,n,p,q);
   a = wv_matalloc(sizeof(int),0,4,m,n,p,q);
   fourdimtest(a, m, n, p, q);
   wv_matfree(a);

   printf("4-dim test wv_matallocv: %d %d %d %d\n",m,n,p,q);
   dims = (unsigned int*)malloc(4*sizeof(unsigned int));
   dims[0]=m; dims[1]=n; dims[2]=p; dims[3]=q;
   a = wv_matallocv(sizeof(int),0,4,dims);
   fourdimtest(a, m, n, p, q);
   wv_matfree(a);
   free(dims);

   nb = 200000;
   printf("1-dim test wv_matalloc:%d\n",nb);
   b=wv_matalloc(sizeof(*b),0,1,nb);
   onedimtest(b,nb);
   wv_matfree(b);

   printf("1-dim test wv_matallocv:%d\n",nb);
   b=wv_matallocv(sizeof(*b),0,1,&nb);
   onedimtest(b,nb);
   wv_matfree(b);

   mc=120; nc=360;
   printf("2-dim test wv_matalloc: %d %d \n",mc,nc);
   c = wv_matalloc(sizeof(**c),0,2,mc,nc);
   twodimtest(c,mc,nc);
   wv_matfree(c);

   printf("2-dim test wv_matallocv: %d %d \n",mc,nc);
   dims = (unsigned int *)malloc(2*sizeof(int));
   dims[0]=mc; dims[1]=nc;
   c = wv_matallocv(sizeof(**c),0,2,dims);
   twodimtest(c,mc,nc);
   wv_matfree(c);
   free(dims);

   printf("3-dim test wv_matalloc: %d %d %d\n",L,M,N);
   dd = wv_matalloc(sizeof(***dd),&d[0][0][0],3,L,M,N);
   threedimtest(dd,L,M,N,d);
   wv_matfree(dd);

   printf("3-dim test wv_matallocv: %d %d %d\n",L,M,N);
   dims=(unsigned int*)malloc(sizeof(unsigned int)*3);
   dims[0]=L; dims[1]=M; dims[2]=N;
   dd = wv_matallocv(sizeof(***dd),&d[0][0][0],3,dims);
   threedimtest(dd,L,M,N,d);
   wv_matfree(dd);
   free(dims);

   return 0;
}

